% 1. op1(s(s(0)), s(0), res)
% op1(0,Y,Y).
% op1(s(X), Y, Res) :- op1(X, s(Y), Res).

% Addition
% > :- X=s(0), Y=s(0), op1(s(0), s(s(0)), Res)
%   :- X=0, Y= s(s(0)),  op1(0, s(s(s(0))), Res)
%   :- 0==0, Y=s(s(s(0))) -> op1(0, s(s(s(0))), s(s(s(0)))).
% BT   op1(s(0), s(s(0)), s(s(s(0))))).
% BT   op1(s(s(0)), s(0), s(s(s(0))))).
% BT   res = s(s(s(0))))


% 2. op2(s(s(s(0))), s(s(0)), Res)
% op2(X, 0, X).
% op2(s(X), s(Y), Res) :- op2(X, Y, Res).

% Soustraction
% > :- X=s(s(0)), Y=s(0), op2(s(s(0)), s(0), Res)
%   :- X=s(0), Y=0, op2(s(0), 0, Res)
%   :- X=s(0), 0==0 -> op2(s(0), 0, s(0)).
% BT op2(s(s(0)), s(0), s(0)).
% BT op2(s(s(s(0))), s(s(0)), s(0)).


% 3. 
% op3([X|_], X).
% op3([_|T], X) :- op3(T, X).

% Contain (Counter)
%    op3([3,1,5], 4) ?
% > :- T=[1,5], X=4, op3([1,5], 4)
%   :- T=[5], X=4, op3([5], 4)
%   :- T=[], X=4, op3([], 4)
%   -> false

%    op3([3,1,5], 5) ?
% > :- T=[1,5], X=5, op3([1,5], 5)
%   :- [X|_]==[5|[]], X=5, op3([5], 5).
% BT   op3([1,5], 5).
% BT   op3([3,1,5], 5).
%   -> true

%    op3([5,3,5], 5) ?
% > :- X=5, [X|_]==[5|[3, 5]], op3([5,3,5], 5).
% BT-> true
%   :- T=[1,5], X=5, op3([1,5], 5)
%   :- [X|_]==[5|[]], X=5, op3([5], 5).
% BT   op3([1,5], 5).
% BT   op3([5,1,5], 5).
%   -> true

% 4. op4([3,1,5], 0, Res) ?
% op4([], X, [X]).
% op4([H|T], X, [H|Res]) :- op4(T, X, Res).

% Append
% > :- H=3, T=[1,5], X=0, op4([1, 5], 0, _Res2)
%   :- H=1, T=[5], X=0, op4([5], 0, _Res3)
%   :- H=5, T=[], X=0, op4([], 0, _Res4)
%   :- []==[], X=0, _Res4=[0], op4([], 0, [0]). 
% BT _Res3=[5|[0]], op4([5], 0, [5, 0]).
% BT _Res2=[1|[5, 0]], op4([1, 5], 0, [1, 5, 0]).
% BT  Res=[3|[1, 5, 0]], op4([3,1,5], 0, [3, 1, 5, 0]).
